#CONST 
########################################

STANDARD_HEADERS = [
  "WWW-Authenticate",
  "Authorization",
  "Proxy-Authenticate",
  "Proxy-Authorization",
  "Age",
  "Cache-Control",
  "Expires",
  "Pragma",
  "Warning",
  "Accept-CH",
  "Accept-CH-Lifetime",
  "Early-Data",
  "Content-DPR",
  "DPR",
  "Downlink",
  "Save-Data",
  "Viewport-Width",
  "Width",
  "Last-Modified",
  "ETag",
  "If-Match",
  "If-None-Match",
  "If-Modified-Since",
  "If-Unmodified-Since",
  "Connection",
  "Keep-Alive",
  "Accept",
  "Accept-Charset",
  "Accept-Encoding",
  "Accept-Language",
  "Expect",
  "Max-Forwards",
  "Cookie",
  "Set-Cookie",
  "Cookie2",
  "Set-Cookie2",
  "Access-Control-Allow-Origin",
  "Access-Control-Allow-Credentials",
  "Access-Control-Allow-Headers",
  "Access-Control-Allow-Methods",
  "Access-Control-Expose-Headers",
  "Access-Control-Max-Age",
  "Access-Control-Request-Headers",
  "Access-Control-Request-Method",
  "Origin",
  "Timing-Allow-Origin",
  "DNT",
  "Tk",
  "Content-Disposition",
  "Content-Length",
  "Content-Type",
  "Content-Encoding",
  "Content-Language",
  "Content-Location",
  "Forwarded",
  "X-Forwarded-For",
  "X-Forwarded-Host",
  "X-Forwarded-Proto",
  "Via",
  "Location",
  "From",
  "Host",
  "Referer",
  "Referrer-Policy",
  "User-Agent",
  "Allow",
  "Server",
  "Accept-Ranges",
  "Range",
  "If-Range",
  "Content-Range",
  "Content-Security-Policy",
  "Content-Security-Policy-Report-Only",
  "Expect-CT",
  "Public-Key-Pins",
  "Public-Key-Pins-Report-Only",
  "Strict-Transport-Security",
  "Upgrade-Insecure-Requests",
  "X-Content-Type-Options",
  "X-Download-Options",
  "X-Frame-Options",
  "X-Permitted-Cross-Domain-Policies",
  "X-Powered-By",
  "X-XSS-Protection",
  "Ping-From",
  "Ping-To",
  "Last-Event-ID",
  "Transfer-Encoding",
  "TE",
  "Trailer",
  "Sec-WebSocket-Key",
  "Sec-WebSocket-Extensions",
  "Sec-WebSocket-Accept",
  "Sec-WebSocket-Protocol",
  "Sec-WebSocket-Version",
  "Date",
  "Expect-CT",
  "Large-Allocation",
  "Link",
  "Retry-After",
  "Server-Timing",
  "SourceMap",
  "Upgrade",
  "Vary",
  "X-DNS-Prefetch-Control",
  "X-Firefox-Spdy",
  "X-Requested-With",
  "X-Robots-Tag",
  "X-UA-Compatible"
]

LOWER_HYPHEN_HEADERS = [
 'www-authenticate',
 'authorization',
 'proxy-authenticate',
 'proxy-authorization',
 'age',
 'cache-control',
 'expires',
 'pragma',
 'warning',
 'accept-ch',
 'accept-ch-lifetime',
 'early-data',
 'content-dpr',
 'dpr',
 'downlink',
 'save-data',
 'viewport-width',
 'width',
 'last-modified',
 'etag',
 'if-match',
 'if-none-match',
 'if-modified-since',
 'if-unmodified-since',
 'connection',
 'keep-alive',
 'accept',
 'accept-charset',
 'accept-encoding',
 'accept-language',
 'expect',
 'max-forwards',
 'cookie',
 'set-cookie',
 'cookie2',
 'set-cookie2',
 'access-control-allow-origin',
 'access-control-allow-credentials',
 'access-control-allow-headers',
 'access-control-allow-methods',
 'access-control-expose-headers',
 'access-control-max-age',
 'access-control-request-headers',
 'access-control-request-method',
 'origin',
 'timing-allow-origin',
 'dnt',
 'tk',
 'content-disposition',
 'content-length',
 'content-type',
 'content-encoding',
 'content-language',
 'content-location',
 'forwarded',
 'x-forwarded-for',
 'x-forwarded-host',
 'x-forwarded-proto',
 'via',
 'location',
 'from',
 'host',
 'referer',
 'referrer-policy',
 'user-agent',
 'allow',
 'server',
 'accept-ranges',
 'range',
 'if-range',
 'content-range',
 'content-security-policy',
 'content-security-policy-report-only',
 'expect-ct',
 'public-key-pins',
 'public-key-pins-report-only',
 'strict-transport-security',
 'upgrade-insecure-requests',
 'x-content-type-options',
 'x-download-options',
 'x-frame-options',
 'x-permitted-cross-domain-policies',
 'x-powered-by',
 'x-xss-protection',
 'ping-from',
 'ping-to',
 'last-event-id',
 'transfer-encoding',
 'te',
 'trailer',
 'sec-websocket-key',
 'sec-websocket-extensions',
 'sec-websocket-accept',
 'sec-websocket-protocol',
 'sec-websocket-version',
 'date',
 'expect-ct',
 'large-allocation',
 'link',
 'retry-after',
 'server-timing',
 'sourcemap',
 'upgrade',
 'vary',
 'x-dns-prefetch-control',
 'x-firefox-spdy',
 'x-requested-with',
 'x-robots-tag',
 'x-ua-compatible'
]

LOWER_UNDERSCORE_HEADERS = [
 'www_authenticate',
 'authorization',
 'proxy_authenticate',
 'proxy_authorization',
 'age',
 'cache_control',
 'expires',
 'pragma',
 'warning',
 'accept_ch',
 'accept_ch_lifetime',
 'early_data',
 'content_dpr',
 'dpr',
 'downlink',
 'save_data',
 'viewport_width',
 'width',
 'last_modified',
 'etag',
 'if_match',
 'if_none_match',
 'if_modified_since',
 'if_unmodified_since',
 'connection',
 'keep_alive',
 'accept',
 'accept_charset',
 'accept_encoding',
 'accept_language',
 'expect',
 'max_forwards',
 'cookie',
 'set_cookie',
 'cookie2',
 'set_cookie2',
 'access_control_allow_origin',
 'access_control_allow_credentials',
 'access_control_allow_headers',
 'access_control_allow_methods',
 'access_control_expose_headers',
 'access_control_max_age',
 'access_control_request_headers',
 'access_control_request_method',
 'origin',
 'timing_allow_origin',
 'dnt',
 'tk',
 'content_disposition',
 'content_length',
 'content_type',
 'content_encoding',
 'content_language',
 'content_location',
 'forwarded',
 'x_forwarded_for',
 'x_forwarded_host',
 'x_forwarded_proto',
 'via',
 'location',
 'from',
 'host',
 'referer',
 'referrer_policy',
 'user_agent',
 'allow',
 'server',
 'accept_ranges',
 'range',
 'if_range',
 'content_range',
 'content_security_policy',
 'content_security_policy_report_only',
 'expect_ct',
 'public_key_pins',
 'public_key_pins_report_only',
 'strict_transport_security',
 'upgrade_insecure_requests',
 'x_content_type_options',
 'x_download_options',
 'x_frame_options',
 'x_permitted_cross_domain_policies',
 'x_powered_by',
 'x_xss_protection',
 'ping_from',
 'ping_to',
 'last_event_id',
 'transfer_encoding',
 'te',
 'trailer',
 'sec_websocket_key',
 'sec_websocket_extensions',
 'sec_websocket_accept',
 'sec_websocket_protocol',
 'sec_websocket_version',
 'date',
 'expect_ct',
 'large_allocation',
 'link',
 'retry_after',
 'server_timing',
 'sourcemap',
 'upgrade',
 'vary',
 'x_dns_prefetch_control',
 'x_firefox_spdy',
 'x_requested_with',
 'x_robots_tag',
 'x_ua_compatible'
]

SPECIFIC_CLASS_NAMES = [
 'WWWAuthenticate',
 'Authorization',
 'ProxyAuthenticate',
 'ProxyAuthorization',
 'Age',
 'CacheControl',
 'Expires',
 'Pragma',
 'Warning',
 'AcceptCH',
 'AcceptCHLifetime',
 'EarlyData',
 'ContentDPR',
 'DPR',
 'Downlink',
 'SaveData',
 'ViewportWidth',
 'Width',
 'LastModified',
 'ETag',
 'IfMatch',
 'IfNoneMatch',
 'IfModifiedSince',
 'IfUnmodifiedSince',
 'Connection',
 'KeepAlive',
 'Accept',
 'AcceptCharset',
 'AcceptEncoding',
 'AcceptLanguage',
 'Expect',
 'MaxForwards',
 'Cookie',
 'SetCookie',
 'Cookie2',
 'SetCookie2',
 'AccessControlAllowOrigin',
 'AccessControlAllowCredentials',
 'AccessControlAllowHeaders',
 'AccessControlAllowMethods',
 'AccessControlExposeHeaders',
 'AccessControlMaxAge',
 'AccessControlRequestHeaders',
 'AccessControlRequestMethod',
 'Origin',
 'TimingAllowOrigin',
 'DNT',
 'Tk',
 'ContentDisposition',
 'ContentLength',
 'ContentType',
 'ContentEncoding',
 'ContentLanguage',
 'ContentLocation',
 'Forwarded',
 'XForwardedFor',
 'XForwardedHost',
 'XForwardedProto',
 'Via',
 'Location',
 'From',
 'Host',
 'Referer',
 'ReferrerPolicy',
 'UserAgent',
 'Allow',
 'Server',
 'AcceptRanges',
 'Range',
 'IfRange',
 'ContentRange',
 'ContentSecurityPolicy',
 'ContentSecurityPolicyReportOnly',
 'ExpectCT',
 'PublicKeyPins',
 'PublicKeyPinsReportOnly',
 'StrictTransportSecurity',
 'UpgradeInsecureRequests',
 'XContentTypeOptions',
 'XDownloadOptions',
 'XFrameOptions',
 'XPermittedCrossDomainPolicies',
 'XPoweredBy',
 'XXSSProtection',
 'PingFrom',
 'PingTo',
 'LastEventID',
 'TransferEncoding',
 'TE',
 'Trailer',
 'SecWebSocketKey',
 'SecWebSocketExtensions',
 'SecWebSocketAccept',
 'SecWebSocketProtocol',
 'SecWebSocketVersion',
 'Date',
 'ExpectCT',
 'LargeAllocation',
 'Link',
 'RetryAfter',
 'ServerTiming',
 'SourceMap',
 'Upgrade',
 'Vary',
 'XDNSPrefetchControl',
 'XFirefoxSpdy',
 'XRequestedWith',
 'XRobotsTag',
 'XUACompatible'
]


#underscore:standard
HEADERS_REF = {
 'www_authenticate': 'WWW-Authenticate',
 'authorization': 'Authorization',
 'proxy_authenticate': 'Proxy-Authenticate',
 'proxy_authorization': 'Proxy-Authorization',
 'age': 'Age',
 'cache_control': 'Cache-Control',
 'expires': 'Expires',
 'pragma': 'Pragma',
 'warning': 'Warning',
 'accept_ch': 'Accept-CH',
 'accept_ch_lifetime': 'Accept-CH-Lifetime',
 'early_data': 'Early-Data',
 'content_dpr': 'Content-DPR',
 'dpr': 'DPR',
 'downlink': 'Downlink',
 'save_data': 'Save-Data',
 'viewport_width': 'Viewport-Width',
 'width': 'Width',
 'last_modified': 'Last-Modified',
 'etag': 'ETag',
 'if_match': 'If-Match',
 'if_none_match': 'If-None-Match',
 'if_modified_since': 'If-Modified-Since',
 'if_unmodified_since': 'If-Unmodified-Since',
 'connection': 'Connection',
 'keep_alive': 'Keep-Alive',
 'accept': 'Accept',
 'accept_charset': 'Accept-Charset',
 'accept_encoding': 'Accept-Encoding',
 'accept_language': 'Accept-Language',
 'expect': 'Expect',
 'max_forwards': 'Max-Forwards',
 'cookie': 'Cookie',
 'set_cookie': 'Set-Cookie',
 'cookie2': 'Cookie2',
 'set_cookie2': 'Set-Cookie2',
 'access_control_allow_origin': 'Access-Control-Allow-Origin',
 'access_control_allow_credentials': 'Access-Control-Allow-Credentials',
 'access_control_allow_headers': 'Access-Control-Allow-Headers',
 'access_control_allow_methods': 'Access-Control-Allow-Methods',
 'access_control_expose_headers': 'Access-Control-Expose-Headers',
 'access_control_max_age': 'Access-Control-Max-Age',
 'access_control_request_headers': 'Access-Control-Request-Headers',
 'access_control_request_method': 'Access-Control-Request-Method',
 'origin': 'Origin',
 'timing_allow_origin': 'Timing-Allow-Origin',
 'dnt': 'DNT',
 'tk': 'Tk',
 'content_disposition': 'Content-Disposition',
 'content_length': 'Content-Length',
 'content_type': 'Content-Type',
 'content_encoding': 'Content-Encoding',
 'content_language': 'Content-Language',
 'content_location': 'Content-Location',
 'forwarded': 'Forwarded',
 'x_forwarded_for': 'X-Forwarded-For',
 'x_forwarded_host': 'X-Forwarded-Host',
 'x_forwarded_proto': 'X-Forwarded-Proto',
 'via': 'Via',
 'location': 'Location',
 'from': 'From',
 'host': 'Host',
 'referer': 'Referer',
 'referrer_policy': 'Referrer-Policy',
 'user_agent': 'User-Agent',
 'allow': 'Allow',
 'server': 'Server',
 'accept_ranges': 'Accept-Ranges',
 'range': 'Range',
 'if_range': 'If-Range',
 'content_range': 'Content-Range',
 'content_security_policy': 'Content-Security-Policy',
 'content_security_policy_report_only': 'Content-Security-Policy-Report-Only',
 'expect_ct': 'Expect-CT',
 'public_key_pins': 'Public-Key-Pins',
 'public_key_pins_report_only': 'Public-Key-Pins-Report-Only',
 'strict_transport_security': 'Strict-Transport-Security',
 'upgrade_insecure_requests': 'Upgrade-Insecure-Requests',
 'x_content_type_options': 'X-Content-Type-Options',
 'x_download_options': 'X-Download-Options',
 'x_frame_options': 'X-Frame-Options',
 'x_permitted_cross_domain_policies': 'X-Permitted-Cross-Domain-Policies',
 'x_powered_by': 'X-Powered-By',
 'x_xss_protection': 'X-XSS-Protection',
 'ping_from': 'Ping-From',
 'ping_to': 'Ping-To',
 'last_event_id': 'Last-Event-ID',
 'transfer_encoding': 'Transfer-Encoding',
 'te': 'TE',
 'trailer': 'Trailer',
 'sec_websocket_key': 'Sec-WebSocket-Key',
 'sec_websocket_extensions': 'Sec-WebSocket-Extensions',
 'sec_websocket_accept': 'Sec-WebSocket-Accept',
 'sec_websocket_protocol': 'Sec-WebSocket-Protocol',
 'sec_websocket_version': 'Sec-WebSocket-Version',
 'date': 'Date',
 'large_allocation': 'Large-Allocation',
 'link': 'Link',
 'retry_after': 'Retry-After',
 'server_timing': 'Server-Timing',
 'sourcemap': 'SourceMap',
 'upgrade': 'Upgrade',
 'vary': 'Vary',
 'x_dns_prefetch_control': 'X-DNS-Prefetch-Control',
 'x_firefox_spdy': 'X-Firefox-Spdy',
 'x_requested_with': 'X-Requested-With',
 'x_robots_tag': 'X-Robots-Tag',
 'x_ua_compatible': 'X-UA-Compatible'
}

#standard:underscore
HEADERS_REF_MD = {
 'WWW-Authenticate': 'www_authenticate',
 'Authorization': 'authorization',
 'Proxy-Authenticate': 'proxy_authenticate',
 'Proxy-Authorization': 'proxy_authorization',
 'Age': 'age',
 'Cache-Control': 'cache_control',
 'Expires': 'expires',
 'Pragma': 'pragma',
 'Warning': 'warning',
 'Accept-CH': 'accept_ch',
 'Accept-CH-Lifetime': 'accept_ch_lifetime',
 'Early-Data': 'early_data',
 'Content-DPR': 'content_dpr',
 'DPR': 'dpr',
 'Downlink': 'downlink',
 'Save-Data': 'save_data',
 'Viewport-Width': 'viewport_width',
 'Width': 'width',
 'Last-Modified': 'last_modified',
 'ETag': 'etag',
 'If-Match': 'if_match',
 'If-None-Match': 'if_none_match',
 'If-Modified-Since': 'if_modified_since',
 'If-Unmodified-Since': 'if_unmodified_since',
 'Connection': 'connection',
 'Keep-Alive': 'keep_alive',
 'Accept': 'accept',
 'Accept-Charset': 'accept_charset',
 'Accept-Encoding': 'accept_encoding',
 'Accept-Language': 'accept_language',
 'Expect': 'expect',
 'Max-Forwards': 'max_forwards',
 'Cookie': 'cookie',
 'Set-Cookie': 'set_cookie',
 'Cookie2': 'cookie2',
 'Set-Cookie2': 'set_cookie2',
 'Access-Control-Allow-Origin': 'access_control_allow_origin',
 'Access-Control-Allow-Credentials': 'access_control_allow_credentials',
 'Access-Control-Allow-Headers': 'access_control_allow_headers',
 'Access-Control-Allow-Methods': 'access_control_allow_methods',
 'Access-Control-Expose-Headers': 'access_control_expose_headers',
 'Access-Control-Max-Age': 'access_control_max_age',
 'Access-Control-Request-Headers': 'access_control_request_headers',
 'Access-Control-Request-Method': 'access_control_request_method',
 'Origin': 'origin',
 'Timing-Allow-Origin': 'timing_allow_origin',
 'DNT': 'dnt',
 'Tk': 'tk',
 'Content-Disposition': 'content_disposition',
 'Content-Length': 'content_length',
 'Content-Type': 'content_type',
 'Content-Encoding': 'content_encoding',
 'Content-Language': 'content_language',
 'Content-Location': 'content_location',
 'Forwarded': 'forwarded',
 'X-Forwarded-For': 'x_forwarded_for',
 'X-Forwarded-Host': 'x_forwarded_host',
 'X-Forwarded-Proto': 'x_forwarded_proto',
 'Via': 'via',
 'Location': 'location',
 'From': 'from',
 'Host': 'host',
 'Referer': 'referer',
 'Referrer-Policy': 'referrer_policy',
 'User-Agent': 'user_agent',
 'Allow': 'allow',
 'Server': 'server',
 'Accept-Ranges': 'accept_ranges',
 'Range': 'range',
 'If-Range': 'if_range',
 'Content-Range': 'content_range',
 'Content-Security-Policy': 'content_security_policy',
 'Content-Security-Policy-Report-Only': 'content_security_policy_report_only',
 'Expect-CT': 'expect_ct',
 'Public-Key-Pins': 'public_key_pins',
 'Public-Key-Pins-Report-Only': 'public_key_pins_report_only',
 'Strict-Transport-Security': 'strict_transport_security',
 'Upgrade-Insecure-Requests': 'upgrade_insecure_requests',
 'X-Content-Type-Options': 'x_content_type_options',
 'X-Download-Options': 'x_download_options',
 'X-Frame-Options': 'x_frame_options',
 'X-Permitted-Cross-Domain-Policies': 'x_permitted_cross_domain_policies',
 'X-Powered-By': 'x_powered_by',
 'X-XSS-Protection': 'x_xss_protection',
 'Ping-From': 'ping_from',
 'Ping-To': 'ping_to',
 'Last-Event-ID': 'last_event_id',
 'Transfer-Encoding': 'transfer_encoding',
 'TE': 'te',
 'Trailer': 'trailer',
 'Sec-WebSocket-Key': 'sec_websocket_key',
 'Sec-WebSocket-Extensions': 'sec_websocket_extensions',
 'Sec-WebSocket-Accept': 'sec_websocket_accept',
 'Sec-WebSocket-Protocol': 'sec_websocket_protocol',
 'Sec-WebSocket-Version': 'sec_websocket_version',
 'Date': 'date',
 'Large-Allocation': 'large_allocation',
 'Link': 'link',
 'Retry-After': 'retry_after',
 'Server-Timing': 'server_timing',
 'SourceMap': 'sourcemap',
 'Upgrade': 'upgrade',
 'Vary': 'vary',
 'X-DNS-Prefetch-Control': 'x_dns_prefetch_control',
 'X-Firefox-Spdy': 'x_firefox_spdy',
 'X-Requested-With': 'x_requested_with',
 'X-Robots-Tag': 'x_robots_tag',
 'X-UA-Compatible': 'x_ua_compatible'
}

#lower:standard
HEADERS_LW2ST_REF = {
 'www-authenticate': 'WWW-Authenticate',
 'authorization': 'Authorization',
 'proxy-authenticate': 'Proxy-Authenticate',
 'proxy-authorization': 'Proxy-Authorization',
 'age': 'Age',
 'cache-control': 'Cache-Control',
 'expires': 'Expires',
 'pragma': 'Pragma',
 'warning': 'Warning',
 'accept-ch': 'Accept-CH',
 'accept-ch-lifetime': 'Accept-CH-Lifetime',
 'early-data': 'Early-Data',
 'content-dpr': 'Content-DPR',
 'dpr': 'DPR',
 'downlink': 'Downlink',
 'save-data': 'Save-Data',
 'viewport-width': 'Viewport-Width',
 'width': 'Width',
 'last-modified': 'Last-Modified',
 'etag': 'ETag',
 'if-match': 'If-Match',
 'if-none-match': 'If-None-Match',
 'if-modified-since': 'If-Modified-Since',
 'if-unmodified-since': 'If-Unmodified-Since',
 'connection': 'Connection',
 'keep-alive': 'Keep-Alive',
 'accept': 'Accept',
 'accept-charset': 'Accept-Charset',
 'accept-encoding': 'Accept-Encoding',
 'accept-language': 'Accept-Language',
 'expect': 'Expect',
 'max-forwards': 'Max-Forwards',
 'cookie': 'Cookie',
 'set-cookie': 'Set-Cookie',
 'cookie2': 'Cookie2',
 'set-cookie2': 'Set-Cookie2',
 'access-control-allow-origin': 'Access-Control-Allow-Origin',
 'access-control-allow-credentials': 'Access-Control-Allow-Credentials',
 'access-control-allow-headers': 'Access-Control-Allow-Headers',
 'access-control-allow-methods': 'Access-Control-Allow-Methods',
 'access-control-expose-headers': 'Access-Control-Expose-Headers',
 'access-control-max-age': 'Access-Control-Max-Age',
 'access-control-request-headers': 'Access-Control-Request-Headers',
 'access-control-request-method': 'Access-Control-Request-Method',
 'origin': 'Origin',
 'timing-allow-origin': 'Timing-Allow-Origin',
 'dnt': 'DNT',
 'tk': 'Tk',
 'content-disposition': 'Content-Disposition',
 'content-length': 'Content-Length',
 'content-type': 'Content-Type',
 'content-encoding': 'Content-Encoding',
 'content-language': 'Content-Language',
 'content-location': 'Content-Location',
 'forwarded': 'Forwarded',
 'x-forwarded-for': 'X-Forwarded-For',
 'x-forwarded-host': 'X-Forwarded-Host',
 'x-forwarded-proto': 'X-Forwarded-Proto',
 'via': 'Via',
 'location': 'Location',
 'from': 'From',
 'host': 'Host',
 'referer': 'Referer',
 'referrer-policy': 'Referrer-Policy',
 'user-agent': 'User-Agent',
 'allow': 'Allow',
 'server': 'Server',
 'accept-ranges': 'Accept-Ranges',
 'range': 'Range',
 'if-range': 'If-Range',
 'content-range': 'Content-Range',
 'content-security-policy': 'Content-Security-Policy',
 'content-security-policy-report-only': 'Content-Security-Policy-Report-Only',
 'expect-ct': 'Expect-CT',
 'public-key-pins': 'Public-Key-Pins',
 'public-key-pins-report-only': 'Public-Key-Pins-Report-Only',
 'strict-transport-security': 'Strict-Transport-Security',
 'upgrade-insecure-requests': 'Upgrade-Insecure-Requests',
 'x-content-type-options': 'X-Content-Type-Options',
 'x-download-options': 'X-Download-Options',
 'x-frame-options': 'X-Frame-Options',
 'x-permitted-cross-domain-policies': 'X-Permitted-Cross-Domain-Policies',
 'x-powered-by': 'X-Powered-By',
 'x-xss-protection': 'X-XSS-Protection',
 'ping-from': 'Ping-From',
 'ping-to': 'Ping-To',
 'last-event-id': 'Last-Event-ID',
 'transfer-encoding': 'Transfer-Encoding',
 'te': 'TE',
 'trailer': 'Trailer',
 'sec-websocket-key': 'Sec-WebSocket-Key',
 'sec-websocket-extensions': 'Sec-WebSocket-Extensions',
 'sec-websocket-accept': 'Sec-WebSocket-Accept',
 'sec-websocket-protocol': 'Sec-WebSocket-Protocol',
 'sec-websocket-version': 'Sec-WebSocket-Version',
 'date': 'Date',
 'large-allocation': 'Large-Allocation',
 'link': 'Link',
 'retry-after': 'Retry-After',
 'server-timing': 'Server-Timing',
 'sourcemap': 'SourceMap',
 'upgrade': 'Upgrade',
 'vary': 'Vary',
 'x-dns-prefetch-control': 'X-DNS-Prefetch-Control',
 'x-firefox-spdy': 'X-Firefox-Spdy',
 'x-requested-with': 'X-Requested-With',
 'x-robots-tag': 'X-Robots-Tag',
 'x-ua-compatible': 'X-UA-Compatible'
}

#standard:lower
HEADERS_ST2LW_REF = {
 'WWW-Authenticate': 'www-authenticate',
 'Authorization': 'authorization',
 'Proxy-Authenticate': 'proxy-authenticate',
 'Proxy-Authorization': 'proxy-authorization',
 'Age': 'age',
 'Cache-Control': 'cache-control',
 'Expires': 'expires',
 'Pragma': 'pragma',
 'Warning': 'warning',
 'Accept-CH': 'accept-ch',
 'Accept-CH-Lifetime': 'accept-ch-lifetime',
 'Early-Data': 'early-data',
 'Content-DPR': 'content-dpr',
 'DPR': 'dpr',
 'Downlink': 'downlink',
 'Save-Data': 'save-data',
 'Viewport-Width': 'viewport-width',
 'Width': 'width',
 'Last-Modified': 'last-modified',
 'ETag': 'etag',
 'If-Match': 'if-match',
 'If-None-Match': 'if-none-match',
 'If-Modified-Since': 'if-modified-since',
 'If-Unmodified-Since': 'if-unmodified-since',
 'Connection': 'connection',
 'Keep-Alive': 'keep-alive',
 'Accept': 'accept',
 'Accept-Charset': 'accept-charset',
 'Accept-Encoding': 'accept-encoding',
 'Accept-Language': 'accept-language',
 'Expect': 'expect',
 'Max-Forwards': 'max-forwards',
 'Cookie': 'cookie',
 'Set-Cookie': 'set-cookie',
 'Cookie2': 'cookie2',
 'Set-Cookie2': 'set-cookie2',
 'Access-Control-Allow-Origin': 'access-control-allow-origin',
 'Access-Control-Allow-Credentials': 'access-control-allow-credentials',
 'Access-Control-Allow-Headers': 'access-control-allow-headers',
 'Access-Control-Allow-Methods': 'access-control-allow-methods',
 'Access-Control-Expose-Headers': 'access-control-expose-headers',
 'Access-Control-Max-Age': 'access-control-max-age',
 'Access-Control-Request-Headers': 'access-control-request-headers',
 'Access-Control-Request-Method': 'access-control-request-method',
 'Origin': 'origin',
 'Timing-Allow-Origin': 'timing-allow-origin',
 'DNT': 'dnt',
 'Tk': 'tk',
 'Content-Disposition': 'content-disposition',
 'Content-Length': 'content-length',
 'Content-Type': 'content-type',
 'Content-Encoding': 'content-encoding',
 'Content-Language': 'content-language',
 'Content-Location': 'content-location',
 'Forwarded': 'forwarded',
 'X-Forwarded-For': 'x-forwarded-for',
 'X-Forwarded-Host': 'x-forwarded-host',
 'X-Forwarded-Proto': 'x-forwarded-proto',
 'Via': 'via',
 'Location': 'location',
 'From': 'from',
 'Host': 'host',
 'Referer': 'referer',
 'Referrer-Policy': 'referrer-policy',
 'User-Agent': 'user-agent',
 'Allow': 'allow',
 'Server': 'server',
 'Accept-Ranges': 'accept-ranges',
 'Range': 'range',
 'If-Range': 'if-range',
 'Content-Range': 'content-range',
 'Content-Security-Policy': 'content-security-policy',
 'Content-Security-Policy-Report-Only': 'content-security-policy-report-only',
 'Expect-CT': 'expect-ct',
 'Public-Key-Pins': 'public-key-pins',
 'Public-Key-Pins-Report-Only': 'public-key-pins-report-only',
 'Strict-Transport-Security': 'strict-transport-security',
 'Upgrade-Insecure-Requests': 'upgrade-insecure-requests',
 'X-Content-Type-Options': 'x-content-type-options',
 'X-Download-Options': 'x-download-options',
 'X-Frame-Options': 'x-frame-options',
 'X-Permitted-Cross-Domain-Policies': 'x-permitted-cross-domain-policies',
 'X-Powered-By': 'x-powered-by',
 'X-XSS-Protection': 'x-xss-protection',
 'Ping-From': 'ping-from',
 'Ping-To': 'ping-to',
 'Last-Event-ID': 'last-event-id',
 'Transfer-Encoding': 'transfer-encoding',
 'TE': 'te',
 'Trailer': 'trailer',
 'Sec-WebSocket-Key': 'sec-websocket-key',
 'Sec-WebSocket-Extensions': 'sec-websocket-extensions',
 'Sec-WebSocket-Accept': 'sec-websocket-accept',
 'Sec-WebSocket-Protocol': 'sec-websocket-protocol',
 'Sec-WebSocket-Version': 'sec-websocket-version',
 'Date': 'date',
 'Large-Allocation': 'large-allocation',
 'Link': 'link',
 'Retry-After': 'retry-after',
 'Server-Timing': 'server-timing',
 'SourceMap': 'sourcemap',
 'Upgrade': 'upgrade',
 'Vary': 'vary',
 'X-DNS-Prefetch-Control': 'x-dns-prefetch-control',
 'X-Firefox-Spdy': 'x-firefox-spdy',
 'X-Requested-With': 'x-requested-with',
 'X-Robots-Tag': 'x-robots-tag',
 'X-UA-Compatible': 'x-ua-compatible'
}

#lower : specific class name 
SPECIFIC_CLASSES_LW2SPCFC_REF = {
 'www_authenticate': 'WWWAuthenticate',
 'authorization': 'Authorization',
 'proxy_authenticate': 'ProxyAuthenticate',
 'proxy_authorization': 'ProxyAuthorization',
 'age': 'Age',
 'cache_control': 'CacheControl',
 'expires': 'Expires',
 'pragma': 'Pragma',
 'warning': 'Warning',
 'accept_ch': 'AcceptCH',
 'accept_ch_lifetime': 'AcceptCHLifetime',
 'early_data': 'EarlyData',
 'content_dpr': 'ContentDPR',
 'dpr': 'DPR',
 'downlink': 'Downlink',
 'save_data': 'SaveData',
 'viewport_width': 'ViewportWidth',
 'width': 'Width',
 'last_modified': 'LastModified',
 'etag': 'ETag',
 'if_match': 'IfMatch',
 'if_none_match': 'IfNoneMatch',
 'if_modified_since': 'IfModifiedSince',
 'if_unmodified_since': 'IfUnmodifiedSince',
 'connection': 'Connection',
 'keep_alive': 'KeepAlive',
 'accept': 'Accept',
 'accept_charset': 'AcceptCharset',
 'accept_encoding': 'AcceptEncoding',
 'accept_language': 'AcceptLanguage',
 'expect': 'Expect',
 'max_forwards': 'MaxForwards',
 'cookie': 'Cookie',
 'set_cookie': 'SetCookie',
 'cookie2': 'Cookie2',
 'set_cookie2': 'SetCookie2',
 'access_control_allow_origin': 'AccessControlAllowOrigin',
 'access_control_allow_credentials': 'AccessControlAllowCredentials',
 'access_control_allow_headers': 'AccessControlAllowHeaders',
 'access_control_allow_methods': 'AccessControlAllowMethods',
 'access_control_expose_headers': 'AccessControlExposeHeaders',
 'access_control_max_age': 'AccessControlMaxAge',
 'access_control_request_headers': 'AccessControlRequestHeaders',
 'access_control_request_method': 'AccessControlRequestMethod',
 'origin': 'Origin',
 'timing_allow_origin': 'TimingAllowOrigin',
 'dnt': 'DNT',
 'tk': 'Tk',
 'content_disposition': 'ContentDisposition',
 'content_length': 'ContentLength',
 'content_type': 'ContentType',
 'content_encoding': 'ContentEncoding',
 'content_language': 'ContentLanguage',
 'content_location': 'ContentLocation',
 'forwarded': 'Forwarded',
 'x_forwarded_for': 'XForwardedFor',
 'x_forwarded_host': 'XForwardedHost',
 'x_forwarded_proto': 'XForwardedProto',
 'via': 'Via',
 'location': 'Location',
 'from': 'From',
 'host': 'Host',
 'referer': 'Referer',
 'referrer_policy': 'ReferrerPolicy',
 'user_agent': 'UserAgent',
 'allow': 'Allow',
 'server': 'Server',
 'accept_ranges': 'AcceptRanges',
 'range': 'Range',
 'if_range': 'IfRange',
 'content_range': 'ContentRange',
 'content_security_policy': 'ContentSecurityPolicy',
 'content_security_policy_report_only': 'ContentSecurityPolicyReportOnly',
 'expect_ct': 'ExpectCT',
 'public_key_pins': 'PublicKeyPins',
 'public_key_pins_report_only': 'PublicKeyPinsReportOnly',
 'strict_transport_security': 'StrictTransportSecurity',
 'upgrade_insecure_requests': 'UpgradeInsecureRequests',
 'x_content_type_options': 'XContentTypeOptions',
 'x_download_options': 'XDownloadOptions',
 'x_frame_options': 'XFrameOptions',
 'x_permitted_cross_domain_policies': 'XPermittedCrossDomainPolicies',
 'x_powered_by': 'XPoweredBy',
 'x_xss_protection': 'XXSSProtection',
 'ping_from': 'PingFrom',
 'ping_to': 'PingTo',
 'last_event_id': 'LastEventID',
 'transfer_encoding': 'TransferEncoding',
 'te': 'TE',
 'trailer': 'Trailer',
 'sec_websocket_key': 'SecWebSocketKey',
 'sec_websocket_extensions': 'SecWebSocketExtensions',
 'sec_websocket_accept': 'SecWebSocketAccept',
 'sec_websocket_protocol': 'SecWebSocketProtocol',
 'sec_websocket_version': 'SecWebSocketVersion',
 'date': 'Date',
 'large_allocation': 'LargeAllocation',
 'link': 'Link',
 'retry_after': 'RetryAfter',
 'server_timing': 'ServerTiming',
 'sourcemap': 'SourceMap',
 'upgrade': 'Upgrade',
 'vary': 'Vary',
 'x_dns_prefetch_control': 'XDNSPrefetchControl',
 'x_firefox_spdy': 'XFirefoxSpdy',
 'x_requested_with': 'XRequestedWith',
 'x_robots_tag': 'XRobotsTag',
 'x_ua_compatible': 'XUACompatible'
}

#specific class name : lower

SPECIFIC_CLASSES_SPCFC2LW_REF = {
 'WWWAuthenticate': 'www_authenticate',
 'Authorization': 'authorization',
 'ProxyAuthenticate': 'proxy_authenticate',
 'ProxyAuthorization': 'proxy_authorization',
 'Age': 'age',
 'CacheControl': 'cache_control',
 'Expires': 'expires',
 'Pragma': 'pragma',
 'Warning': 'warning',
 'AcceptCH': 'accept_ch',
 'AcceptCHLifetime': 'accept_ch_lifetime',
 'EarlyData': 'early_data',
 'ContentDPR': 'content_dpr',
 'DPR': 'dpr',
 'Downlink': 'downlink',
 'SaveData': 'save_data',
 'ViewportWidth': 'viewport_width',
 'Width': 'width',
 'LastModified': 'last_modified',
 'ETag': 'etag',
 'IfMatch': 'if_match',
 'IfNoneMatch': 'if_none_match',
 'IfModifiedSince': 'if_modified_since',
 'IfUnmodifiedSince': 'if_unmodified_since',
 'Connection': 'connection',
 'KeepAlive': 'keep_alive',
 'Accept': 'accept',
 'AcceptCharset': 'accept_charset',
 'AcceptEncoding': 'accept_encoding',
 'AcceptLanguage': 'accept_language',
 'Expect': 'expect',
 'MaxForwards': 'max_forwards',
 'Cookie': 'cookie',
 'SetCookie': 'set_cookie',
 'Cookie2': 'cookie2',
 'SetCookie2': 'set_cookie2',
 'AccessControlAllowOrigin': 'access_control_allow_origin',
 'AccessControlAllowCredentials': 'access_control_allow_credentials',
 'AccessControlAllowHeaders': 'access_control_allow_headers',
 'AccessControlAllowMethods': 'access_control_allow_methods',
 'AccessControlExposeHeaders': 'access_control_expose_headers',
 'AccessControlMaxAge': 'access_control_max_age',
 'AccessControlRequestHeaders': 'access_control_request_headers',
 'AccessControlRequestMethod': 'access_control_request_method',
 'Origin': 'origin',
 'TimingAllowOrigin': 'timing_allow_origin',
 'DNT': 'dnt',
 'Tk': 'tk',
 'ContentDisposition': 'content_disposition',
 'ContentLength': 'content_length',
 'ContentType': 'content_type',
 'ContentEncoding': 'content_encoding',
 'ContentLanguage': 'content_language',
 'ContentLocation': 'content_location',
 'Forwarded': 'forwarded',
 'XForwardedFor': 'x_forwarded_for',
 'XForwardedHost': 'x_forwarded_host',
 'XForwardedProto': 'x_forwarded_proto',
 'Via': 'via',
 'Location': 'location',
 'From': 'from',
 'Host': 'host',
 'Referer': 'referer',
 'ReferrerPolicy': 'referrer_policy',
 'UserAgent': 'user_agent',
 'Allow': 'allow',
 'Server': 'server',
 'AcceptRanges': 'accept_ranges',
 'Range': 'range',
 'IfRange': 'if_range',
 'ContentRange': 'content_range',
 'ContentSecurityPolicy': 'content_security_policy',
 'ContentSecurityPolicyReportOnly': 'content_security_policy_report_only',
 'ExpectCT': 'expect_ct',
 'PublicKeyPins': 'public_key_pins',
 'PublicKeyPinsReportOnly': 'public_key_pins_report_only',
 'StrictTransportSecurity': 'strict_transport_security',
 'UpgradeInsecureRequests': 'upgrade_insecure_requests',
 'XContentTypeOptions': 'x_content_type_options',
 'XDownloadOptions': 'x_download_options',
 'XFrameOptions': 'x_frame_options',
 'XPermittedCrossDomainPolicies': 'x_permitted_cross_domain_policies',
 'XPoweredBy': 'x_powered_by',
 'XXSSProtection': 'x_xss_protection',
 'PingFrom': 'ping_from',
 'PingTo': 'ping_to',
 'LastEventID': 'last_event_id',
 'TransferEncoding': 'transfer_encoding',
 'TE': 'te',
 'Trailer': 'trailer',
 'SecWebSocketKey': 'sec_websocket_key',
 'SecWebSocketExtensions': 'sec_websocket_extensions',
 'SecWebSocketAccept': 'sec_websocket_accept',
 'SecWebSocketProtocol': 'sec_websocket_protocol',
 'SecWebSocketVersion': 'sec_websocket_version',
 'Date': 'date',
 'LargeAllocation': 'large_allocation',
 'Link': 'link',
 'RetryAfter': 'retry_after',
 'ServerTiming': 'server_timing',
 'SourceMap': 'sourcemap',
 'Upgrade': 'upgrade',
 'Vary': 'vary',
 'XDNSPrefetchControl': 'x_dns_prefetch_control',
 'XFirefoxSpdy': 'x_firefox_spdy',
 'XRequestedWith': 'x_requested_with',
 'XRobotsTag': 'x_robots_tag',
 'XUACompatible': 'x_ua_compatible'
}

#standard : specific class name

SPECIFIC_CLASSES_ST2SPCFC_REF = {
 'WWW-Authenticate': 'WWWAuthenticate',
 'Authorization': 'Authorization',
 'Proxy-Authenticate': 'ProxyAuthenticate',
 'Proxy-Authorization': 'ProxyAuthorization',
 'Age': 'Age',
 'Cache-Control': 'CacheControl',
 'Expires': 'Expires',
 'Pragma': 'Pragma',
 'Warning': 'Warning',
 'Accept-CH': 'AcceptCH',
 'Accept-CH-Lifetime': 'AcceptCHLifetime',
 'Early-Data': 'EarlyData',
 'Content-DPR': 'ContentDPR',
 'DPR': 'DPR',
 'Downlink': 'Downlink',
 'Save-Data': 'SaveData',
 'Viewport-Width': 'ViewportWidth',
 'Width': 'Width',
 'Last-Modified': 'LastModified',
 'ETag': 'ETag',
 'If-Match': 'IfMatch',
 'If-None-Match': 'IfNoneMatch',
 'If-Modified-Since': 'IfModifiedSince',
 'If-Unmodified-Since': 'IfUnmodifiedSince',
 'Connection': 'Connection',
 'Keep-Alive': 'KeepAlive',
 'Accept': 'Accept',
 'Accept-Charset': 'AcceptCharset',
 'Accept-Encoding': 'AcceptEncoding',
 'Accept-Language': 'AcceptLanguage',
 'Expect': 'Expect',
 'Max-Forwards': 'MaxForwards',
 'Cookie': 'Cookie',
 'Set-Cookie': 'SetCookie',
 'Cookie2': 'Cookie2',
 'Set-Cookie2': 'SetCookie2',
 'Access-Control-Allow-Origin': 'AccessControlAllowOrigin',
 'Access-Control-Allow-Credentials': 'AccessControlAllowCredentials',
 'Access-Control-Allow-Headers': 'AccessControlAllowHeaders',
 'Access-Control-Allow-Methods': 'AccessControlAllowMethods',
 'Access-Control-Expose-Headers': 'AccessControlExposeHeaders',
 'Access-Control-Max-Age': 'AccessControlMaxAge',
 'Access-Control-Request-Headers': 'AccessControlRequestHeaders',
 'Access-Control-Request-Method': 'AccessControlRequestMethod',
 'Origin': 'Origin',
 'Timing-Allow-Origin': 'TimingAllowOrigin',
 'DNT': 'DNT',
 'Tk': 'Tk',
 'Content-Disposition': 'ContentDisposition',
 'Content-Length': 'ContentLength',
 'Content-Type': 'ContentType',
 'Content-Encoding': 'ContentEncoding',
 'Content-Language': 'ContentLanguage',
 'Content-Location': 'ContentLocation',
 'Forwarded': 'Forwarded',
 'X-Forwarded-For': 'XForwardedFor',
 'X-Forwarded-Host': 'XForwardedHost',
 'X-Forwarded-Proto': 'XForwardedProto',
 'Via': 'Via',
 'Location': 'Location',
 'From': 'From',
 'Host': 'Host',
 'Referer': 'Referer',
 'Referrer-Policy': 'ReferrerPolicy',
 'User-Agent': 'UserAgent',
 'Allow': 'Allow',
 'Server': 'Server',
 'Accept-Ranges': 'AcceptRanges',
 'Range': 'Range',
 'If-Range': 'IfRange',
 'Content-Range': 'ContentRange',
 'Content-Security-Policy': 'ContentSecurityPolicy',
 'Content-Security-Policy-Report-Only': 'ContentSecurityPolicyReportOnly',
 'Expect-CT': 'ExpectCT',
 'Public-Key-Pins': 'PublicKeyPins',
 'Public-Key-Pins-Report-Only': 'PublicKeyPinsReportOnly',
 'Strict-Transport-Security': 'StrictTransportSecurity',
 'Upgrade-Insecure-Requests': 'UpgradeInsecureRequests',
 'X-Content-Type-Options': 'XContentTypeOptions',
 'X-Download-Options': 'XDownloadOptions',
 'X-Frame-Options': 'XFrameOptions',
 'X-Permitted-Cross-Domain-Policies': 'XPermittedCrossDomainPolicies',
 'X-Powered-By': 'XPoweredBy',
 'X-XSS-Protection': 'XXSSProtection',
 'Ping-From': 'PingFrom',
 'Ping-To': 'PingTo',
 'Last-Event-ID': 'LastEventID',
 'Transfer-Encoding': 'TransferEncoding',
 'TE': 'TE',
 'Trailer': 'Trailer',
 'Sec-WebSocket-Key': 'SecWebSocketKey',
 'Sec-WebSocket-Extensions': 'SecWebSocketExtensions',
 'Sec-WebSocket-Accept': 'SecWebSocketAccept',
 'Sec-WebSocket-Protocol': 'SecWebSocketProtocol',
 'Sec-WebSocket-Version': 'SecWebSocketVersion',
 'Date': 'Date',
 'Large-Allocation': 'LargeAllocation',
 'Link': 'Link',
 'Retry-After': 'RetryAfter',
 'Server-Timing': 'ServerTiming',
 'SourceMap': 'SourceMap',
 'Upgrade': 'Upgrade',
 'Vary': 'Vary',
 'X-DNS-Prefetch-Control': 'XDNSPrefetchControl',
 'X-Firefox-Spdy': 'XFirefoxSpdy',
 'X-Requested-With': 'XRequestedWith',
 'X-Robots-Tag': 'XRobotsTag',
 'X-UA-Compatible': 'XUACompatible'
}

#specific class name : standard
SPECIFIC_CLASSES_SPCFC2ST_REF = {
 'WWWAuthenticate': 'WWW-Authenticate',
 'Authorization': 'Authorization',
 'ProxyAuthenticate': 'Proxy-Authenticate',
 'ProxyAuthorization': 'Proxy-Authorization',
 'Age': 'Age',
 'CacheControl': 'Cache-Control',
 'Expires': 'Expires',
 'Pragma': 'Pragma',
 'Warning': 'Warning',
 'AcceptCH': 'Accept-CH',
 'AcceptCHLifetime': 'Accept-CH-Lifetime',
 'EarlyData': 'Early-Data',
 'ContentDPR': 'Content-DPR',
 'DPR': 'DPR',
 'Downlink': 'Downlink',
 'SaveData': 'Save-Data',
 'ViewportWidth': 'Viewport-Width',
 'Width': 'Width',
 'LastModified': 'Last-Modified',
 'ETag': 'ETag',
 'IfMatch': 'If-Match',
 'IfNoneMatch': 'If-None-Match',
 'IfModifiedSince': 'If-Modified-Since',
 'IfUnmodifiedSince': 'If-Unmodified-Since',
 'Connection': 'Connection',
 'KeepAlive': 'Keep-Alive',
 'Accept': 'Accept',
 'AcceptCharset': 'Accept-Charset',
 'AcceptEncoding': 'Accept-Encoding',
 'AcceptLanguage': 'Accept-Language',
 'Expect': 'Expect',
 'MaxForwards': 'Max-Forwards',
 'Cookie': 'Cookie',
 'SetCookie': 'Set-Cookie',
 'Cookie2': 'Cookie2',
 'SetCookie2': 'Set-Cookie2',
 'AccessControlAllowOrigin': 'Access-Control-Allow-Origin',
 'AccessControlAllowCredentials': 'Access-Control-Allow-Credentials',
 'AccessControlAllowHeaders': 'Access-Control-Allow-Headers',
 'AccessControlAllowMethods': 'Access-Control-Allow-Methods',
 'AccessControlExposeHeaders': 'Access-Control-Expose-Headers',
 'AccessControlMaxAge': 'Access-Control-Max-Age',
 'AccessControlRequestHeaders': 'Access-Control-Request-Headers',
 'AccessControlRequestMethod': 'Access-Control-Request-Method',
 'Origin': 'Origin',
 'TimingAllowOrigin': 'Timing-Allow-Origin',
 'DNT': 'DNT',
 'Tk': 'Tk',
 'ContentDisposition': 'Content-Disposition',
 'ContentLength': 'Content-Length',
 'ContentType': 'Content-Type',
 'ContentEncoding': 'Content-Encoding',
 'ContentLanguage': 'Content-Language',
 'ContentLocation': 'Content-Location',
 'Forwarded': 'Forwarded',
 'XForwardedFor': 'X-Forwarded-For',
 'XForwardedHost': 'X-Forwarded-Host',
 'XForwardedProto': 'X-Forwarded-Proto',
 'Via': 'Via',
 'Location': 'Location',
 'From': 'From',
 'Host': 'Host',
 'Referer': 'Referer',
 'ReferrerPolicy': 'Referrer-Policy',
 'UserAgent': 'User-Agent',
 'Allow': 'Allow',
 'Server': 'Server',
 'AcceptRanges': 'Accept-Ranges',
 'Range': 'Range',
 'IfRange': 'If-Range',
 'ContentRange': 'Content-Range',
 'ContentSecurityPolicy': 'Content-Security-Policy',
 'ContentSecurityPolicyReportOnly': 'Content-Security-Policy-Report-Only',
 'ExpectCT': 'Expect-CT',
 'PublicKeyPins': 'Public-Key-Pins',
 'PublicKeyPinsReportOnly': 'Public-Key-Pins-Report-Only',
 'StrictTransportSecurity': 'Strict-Transport-Security',
 'UpgradeInsecureRequests': 'Upgrade-Insecure-Requests',
 'XContentTypeOptions': 'X-Content-Type-Options',
 'XDownloadOptions': 'X-Download-Options',
 'XFrameOptions': 'X-Frame-Options',
 'XPermittedCrossDomainPolicies': 'X-Permitted-Cross-Domain-Policies',
 'XPoweredBy': 'X-Powered-By',
 'XXSSProtection': 'X-XSS-Protection',
 'PingFrom': 'Ping-From',
 'PingTo': 'Ping-To',
 'LastEventID': 'Last-Event-ID',
 'TransferEncoding': 'Transfer-Encoding',
 'TE': 'TE',
 'Trailer': 'Trailer',
 'SecWebSocketKey': 'Sec-WebSocket-Key',
 'SecWebSocketExtensions': 'Sec-WebSocket-Extensions',
 'SecWebSocketAccept': 'Sec-WebSocket-Accept',
 'SecWebSocketProtocol': 'Sec-WebSocket-Protocol',
 'SecWebSocketVersion': 'Sec-WebSocket-Version',
 'Date': 'Date',
 'LargeAllocation': 'Large-Allocation',
 'Link': 'Link',
 'RetryAfter': 'Retry-After',
 'ServerTiming': 'Server-Timing',
 'SourceMap': 'SourceMap',
 'Upgrade': 'Upgrade',
 'Vary': 'Vary',
 'XDNSPrefetchControl': 'X-DNS-Prefetch-Control',
 'XFirefoxSpdy': 'X-Firefox-Spdy',
 'XRequestedWith': 'X-Requested-With',
 'XRobotsTag': 'X-Robots-Tag',
 'XUACompatible': 'X-UA-Compatible'
}



